import numpy as np
import cv2
from matplotlib import pyplot as plt
from math import sqrt
from Functions_Sorting import *
import sys

tabx=[]
taby=[]
tabz=[]


def Keypoints(filename):  # Creation of the function that finds Keypoints
  
	img = cv2.imread(filename)
	imdep = cv2.imread(filename)
	
	# Initiate STAR detector
	orb = cv2.ORB_create(6000)
	
	# find the keypoints with ORB
	kp = orb.detect(img,None)
	
	# compute the descriptors with ORB
	kp, des = orb.compute(img, kp)
	
	# draw only keypoints location,not size and orientation
	img2 = cv2.drawKeypoints(imdep,kp,None,color=(0,255,0), flags=0)
	
	n= len(kp)
	cd_x = np.zeros(n, dtype=np.int)
	cd_y = np.zeros(n, dtype=np.int)
	for i in range (0, n):
		cd_x[i] = kp[i].pt[0]
		cd_y[i] = kp[i].pt[1]
	
	cd = []
	cd = np.column_stack((cd_x,cd_y))
	print(cd)
	
	String_Name_txt=filename+'.txt'
	
	np.savetxt(String_Name_txt, cd, fmt='%i')

	return String_Name_txt


def correct_keypoints(txtfile):  # Correction of the order of the points created with Keypoints

	points1 = np.loadtxt(txtfile)
	
	NbPoints= int(points1.size/2)
	
	Distance_Array = np.zeros(NbPoints)
	
	
	for row in range(0, NbPoints):
		x = points1[row,0]
		y = points1[row,1]
	
	
	d = distance(x,y,0,0)
	
	#fulfil the array
	Distance_Array[row] = d
	
	
	#np.sort(Distance_Array)
	int_sort = np.argsort(Distance_Array)
	print(Distance_Array)
	
	#store the array in a txt file 'distances.txt'
	NewPoints = reorder(points1, int_sort)
	print(NewPoints)

	String_Name_txt=txtfile+'corrected.txt'
	
	np.savetxt(String_Name_txt, NewPoints, fmt='%i')
	return String_Name_txt


